<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8">
    <meta content="width=device-width, initial-scale=1" name="viewport">
    <title></title>
    <link crossorigin="anonymous" href="//cdnjs.cloudflare.com/ajax/libs/bulma/0.7.4/css/bulma.min.css"
          integrity="sha256-8B1OaG0zT7uYA572S2xOxWACq9NXYPQ+U5kHPV1bJN4=" rel="stylesheet"/>
    <script src="https://cdn.jsdelivr.net/npm/es6-promise@4/dist/es6-promise.auto.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>
<body class="page-columns">
<br/>
<div id="app">
    <div class="columns is-mobile is-centered">
        <div class="column is-half">
            <div class="field is-grouped is-grouped-centered">
                <p class="control">
                    <a class="button is-primary" v-if="!fetching" v-on:click="fetchArticles">
                        Find wiki-articles nearby my location
                    </a>
                </p>
            </div>
            <br/>
            <progress-bar v-bind:show="fetching"></progress-bar>
            <ul>
                <article-item
                        v-bind:key="article.pageId"
                        v-bind:title="article.title"
                        v-bind:url="article.url"
                        v-for="article in articles"
                ></article-item>
            </ul>
        </div>
    </div>
</div>

</body>
<script>
    var HOST_PREFIX = "";

    Vue.component('article-item', {
        props: ['title', 'url'],
        template: '<li><a :href=url target="_blank">{{ title }}</a></li>'
    });

    Vue.component('progress-bar', {
        props: ['show'],
        template: '<span v-if="show"><progress class="progress is-small is-primary" max="100">15%</progress></span>'
    });

    var defaultPosition = {lat: 55.816192, lng: 37.6471552};

    var app = new Vue({
        el: '#app',
        data: {
            fetching: false,
            errorOccurs: false,
            articles: []
        },
        methods: {
            fetchArticles: function () {
                if (!this.fetching) {
                    this.errorOccurs = false;
                    this.fetching = true;
                    this.articles = [];

                    var self = this;

                    getPosition()
                        .catch(defaultPosition)
                        .then(fetchArticles)
                        .then(function (articles) {
                            self.articles = articles;
                        }).catch(function (error) {
                        self.articles = [];
                        self.errorOccurs = true;
                    }).finally(function () {
                        self.fetching = false;
                    });
                }
            }

        }
    });

    function getPosition(options) {
        return new Promise(function (resolve, reject) {
            navigator.geolocation.getCurrentPosition(resolve, reject, options);
        }).then(function (position) {
            return {lat: position.coords.latitude, lng: position.coords.longitude}
        });
    }

    function fetchArticles(geoLocation) {
        return fetch(HOST_PREFIX + "/articles/near?lat=" + geoLocation.lat + "&lng=" + geoLocation.lng)
            .then(function (response) {
                return response.json();
            });
    }


</script>
</html>
